// User defined constants

const myToolbarName = "IME Toolbar"; // 
const myToolbarId = "imetoolbar"; // <toolbar>'s id
const myMenulistId = "imetoolbarSearchText";
const myKeyboardMenuList = "keyboardlist";
const myLanguageMenuList = "languagelist";

/* toolbar interface

Method List

DisplayCheck()						Checks if the current window has the location bar hidden, 
													and if yes, hides the toolbar
LoadPage(url)        			Loads the url
Uninstall            			Uninstalls the toolbar.

Note:For Other methods, please refer to the documentation written with the method definition
*/

function imetoolbar() {
  this.myToolbarId = myToolbarId;
  this.myMenulistId = myMenulistId;
  this.myKeyboardMenuList = myKeyboardMenuList;
  this.myLanguageMenuList = myLanguageMenuList;
	this.initializeArray();
  document.onkeypress = this.eventCaptured;// For IE 
};

var vowelFlag = false;
var vowel_nn = false;
var offset=0;
var convertFlag;
var isciiToUnicodeArray = new Array();
var hindiUnicodeStart = 2304;
var currentTextControl;
var isNav = false;
var w,langIndex;
var imatraFlag = false;
var oldSelectionStart,oldSelectionEnd;
var keyboardSelected;
var windowObject;

imetoolbar.prototype.DisplayCheck = function (){
  var main = document.getElementById("main-window");
  var myToolbar = document.getElementById(myToolbarId);

  if (main.hasAttribute("chromehidden") && (myToolbar != null)) {
    if (main.getAttribute("chromehidden").indexOf("location") != -1) {
      myToolbar.setAttribute("collapsed", "true");
      myToolbar.setAttribute("hidden", "true");
    }
  }
}

imetoolbar.prototype.LoadPage = function(url){
  window.content.document.location.href=url;
}

/**
  * Stores the index of the language selected in a global variable and also calls
	* setOffset method which calculates the offset for the language selected.
	*/

imetoolbar.prototype.setLanguageIndex = function(languageIndex) {
	if(typeof keyboardSelected != 'undefined') {
		langIndex = languageIndex;
		this.setOffset(languageIndex);
	}
	else {
		var languagelistref = document.getElementById(myLanguageMenuList);
		languagelistref.selectedIndex = 0;
		alert("Please select a keyboard Layout from the 'Select keyboard' dropdown..!!!");
	}
}

/**
  * Initializes the ISCII to Unicode Array.
  */
imetoolbar.prototype.initializeArray = function () {
	isciiToUnicodeArray.push(2305); // ISCII 161
	isciiToUnicodeArray.push(2306); // ISCII 162
	isciiToUnicodeArray.push(2307); // ISCII 163
	isciiToUnicodeArray.push(2309); // ISCII 164
	isciiToUnicodeArray.push(2310); // ISCII 165
	isciiToUnicodeArray.push(2311); // ISCII 166
	isciiToUnicodeArray.push(2312); // ISCII 167
	isciiToUnicodeArray.push(2313); // ISCII 168
	isciiToUnicodeArray.push(2314); // ISCII 169
	isciiToUnicodeArray.push(2315); // ISCII 170
	isciiToUnicodeArray.push(2318); // ISCII 171
	isciiToUnicodeArray.push(2319); // ISCII 172
	isciiToUnicodeArray.push(2320); // ISCII 173
	isciiToUnicodeArray.push(2317); // ISCII 174
	isciiToUnicodeArray.push(2322); // ISCII 175
	isciiToUnicodeArray.push(2323); // ISCII 176
	isciiToUnicodeArray.push(2324); // ISCII 177
	isciiToUnicodeArray.push(2321); // ISCII 178
	var uniHinCons = 2325;
	for(var i=180;i<=223;i++) {
	   if(i == 217) {
				isciiToUnicodeArray.push(0);
				uniHinCons = 2366;
	   }
		 isciiToUnicodeArray.push(uniHinCons);
		 uniHinCons++;
	}
	isciiToUnicodeArray.push(2374); // ISCII 224
	isciiToUnicodeArray.push(2375); // ISCII 225
	isciiToUnicodeArray.push(2376); // ISCII 226
	isciiToUnicodeArray.push(2373); // ISCII 227
	isciiToUnicodeArray.push(2378); // ISCII 228
	isciiToUnicodeArray.push(2379); // ISCII 229
	isciiToUnicodeArray.push(2380); // ISCII 230
	isciiToUnicodeArray.push(2377); // ISCII 231
	isciiToUnicodeArray.push(2378); // ISCII 232
	isciiToUnicodeArray.push(2364); // ISCII 233
	isciiToUnicodeArray.push(2404); // ISCII 234
	for(var i=235;i<=240;i++) {
	  isciiToUnicodeArray.push(0);
	}
	var hinUnicodeDigits = 2406;  
	for(var i=241;i<=250;i++) {
		isciiToUnicodeArray.push(hinUnicodeDigits);
		hinUnicodeDigits++;
	}
		
	if(parseInt(navigator.appVersion)>=4) {
		if(navigator.appName=="Netscape") {
			isNav = true;
		}
	}
	else 
		isNav = false;
}		

/**
  * Stores the keyboard selected in a global variable.
	*/

imetoolbar.prototype.setSelectedKeyboard = function(keyboardLayout) {
	keyboardSelected = keyboardLayout;
}


/**
  * This function captures the Keypress event and handles the event accordingly.
  */
imetoolbar.prototype.eventCaptured = function(evt) {
	if(evt.target.type=="textarea" || evt.target.type=="text") {
		var target = evt.target;
   	handleCharacter(target,evt);
	}
  var shift,virKeyboard,path;
  if(isNav) {
		shift =  evt.modifiers & Event.SHIFT_MASK;
	}
	else {
		shift = window.event.shiftKey;
	}

	/**
	  * Returns the unicode corresponding to key typed in for WX layout.
	  */
	
	function getUnicodeMappingForWxLayout(keyCode) {
		var key = String.fromCharCode(keyCode);
		if(vowelFlag) {
			switch(key) {
				case 'A': { vowel_nn = navigator.appName=="Netscape" ? 
										true : false ;vowelFlag = false;
										return {newKeyCode1:0, newKeyCode2:(2310+offset)};
										break;
				}
				case 'i': { vowel_nn = navigator.appName=="Netscape" ? 
										true : false;vowelFlag = false;
										return { newKeyCode1:0, newKeyCode2:(2311+offset) };
										break;
				}
				case 'I': { vowel_nn = navigator.appName=="Netscape" ?
										true : false;vowelFlag = false; 
										return { newKeyCode1:0, newKeyCode2:(2312+offset) }; 
										break;
				}
				case 'u': { vowel_nn = navigator.appName=="Netscape" ?
										true : false;vowelFlag = false;
										return { newKeyCode1:0, newKeyCode2:(2313+offset) }; 
										break;
				}
				case 'U': { vowel_nn = navigator.appName=="Netscape" ?
										true : false;vowelFlag = false;
										return { newKeyCode1:0, newKeyCode2:(2314+offset) };
										break;
				}
				case 'q': { vowel_nn = navigator.appName=="Netscape" ? 
										true : false;vowelFlag = false;
										if(offset != 640) {
											return { newKeyCode1:0, newKeyCode2:(2315+offset) }; 
										}
										else {
											if(navigator.appName=="Netscape") {
												return { newKeyCode1:0,newKeyCode2:-1};
											}
											else {
												return { newKeyCode1:0,newKeyCode2:0};
											}
										}  
										break;
				}
				case 'L': { 
										vowel_nn = navigator.appName=="Netscape" ? 
										true : false;vowelFlag = false;
										if(offset != 640) {
											return { newKeyCode1:0, newKeyCode2:(2316+offset) }; 
										}
										else{
											if(navigator.appName=="Netscape") {
												return { newKeyCode1:0, newKeyCode2:-1 }; 
											}
										else {   
											return { newKeyCode1:0,newKeyCode2:0};
										}
									}
									break;
				}
				case 'e': { vowel_nn = navigator.appName=="Netscape" ? 
										true : false;vowelFlag = false; 
										return { newKeyCode1:0, newKeyCode2:(2319+offset) }; 
										break;
				}
				case 'E': { vowel_nn = navigator.appName=="Netscape" ? 
										true : false;vowelFlag = false;
										return { newKeyCode1:0, newKeyCode2:(2320+offset) }; 
										break;
				}
				case 'o': { vowel_nn = navigator.appName=="Netscape" ? 
										true : false;vowelFlag = false;
										return { newKeyCode1:0, newKeyCode2:(2323+offset) }; 
										break;
				}
				case 'O': { vowel_nn = navigator.appName=="Netscape" ? 
										true : false;vowelFlag = false;
										return { newKeyCode1:0, newKeyCode2:(2324+offset) }; 
										break;
				}
				case 'Q': {	
										if(offset != 640) { // if input language is not Tamil
											vowel_nn = navigator.appName=="Netscape" ?
											true : false;vowelFlag = false;
											return { newKeyCode1:0, newKeyCode2:(2400+offset) }; 
										}
										break;
				}
				default : { 
										vowelFlag = false; 
										return { 
											newKeyCode1:getConsonant(keyCode), newKeyCode2:(2309+offset)
										};
									break;
				}
			}
		}
		else {
			var newKeyCode = getConsonant(keyCode);
			return { newKeyCode1:0, newKeyCode2:newKeyCode };
		}
	}

	/**
	  * Returns the unicode corresponding to key typed in for Inscript layout.
	  */

	function getUnicodeMappingForInscriptLayout(keyCode) {
		var key = String.fromCharCode(keyCode);
		var newChar,replace;
		switch(key) {
			case 'a':{ replace=true;newChar=getChar(2379+offset);break; }
			case 'A':{ replace=true;newChar=getChar(2323+offset);break; }
			case 'b':{ replace=true;newChar=getChar(2357+offset);break; }
			case 'B':{ replace=true;newChar=getChar(2356+offset);break; }
			case 'c':{ replace=true;newChar=getChar(2350+offset);break; }
			case 'C':{ replace=true;newChar=getChar(2339+offset);break; }
			case 'd':{ replace=true;newChar=getChar(2381+offset);break; }
			case 'D':{ replace=true;newChar=getChar(2309+offset);break; }
			case 'e':{ replace=true;newChar=getChar(2366+offset);break; }
			case 'E':{ replace=true;newChar=getChar(2310+offset);break; }
			case 'f':{ replace=true;newChar=getChar(2367+offset);break; }
			case 'F':{ replace=true;newChar=getChar(2311+offset);break; }
			case 'g':{ replace=true;newChar=getChar(2369+offset);break; }
			case 'G':{ replace=true;newChar=getChar(2313+offset);break; }
			case 'h':{ replace=true;newChar=getChar(2346+offset);break; }
			case 'H':{ replace=true;newChar=getChar(2347+offset);break; }
			case 'i':{ replace=true;newChar=getChar(2327+offset);break; }
			case 'I':{ replace=true;newChar=getChar(2328+offset);break; }
			case 'j':{ replace=true;newChar=getChar(2352+offset);break; }
			case 'J':{ replace=true;newChar=getChar(2353+offset);break; }
			case 'k':{ replace=true;newChar=getChar(2325+offset);break; }
			case 'K':{ replace=true;newChar=getChar(2326+offset);break; }
			case 'l':{ replace=true;newChar=getChar(2340+offset);break; }
			case 'L':{ replace=true;newChar=getChar(2341+offset);break; }
			case 'm':{ replace=true;newChar=getChar(2360+offset);break; }
			case 'M':{ replace=true;newChar=getChar(2358+offset);break; }
			case 'n':{ replace=true;newChar=getChar(2354+offset);break; }
			case 'N':{ replace=true;newChar=getChar(2355+offset);break; }
			case 'o':{ replace=true;newChar=getChar(2342+offset);break; }
			case 'O':{ replace=true;newChar=getChar(2343+offset);break; }
			case 'p':{ replace=true;newChar=getChar(2332+offset);break; }
			case 'P':{ replace=true;newChar=getChar(2333+offset);break; }
			case 'q':{ replace=true;newChar=getChar(2380+offset);break; }
			case 'Q':{ replace=true;newChar=getChar(2324+offset);break; }
			case 'r':{ replace=true;newChar=getChar(2368+offset);break; }
			case 'R':{ replace=true;newChar=getChar(2312+offset);break; }
			case 's':{ replace=true;newChar=getChar(2375+offset);break; }
			case 'S':{ replace=true;newChar=getChar(2319+offset);break; }
			case 't':{ replace=true;newChar=getChar(2370+offset);break; }
			case 'T':{ replace=true;newChar=getChar(2314+offset);break; }
			case 'u':{ replace=true;newChar=getChar(2361+offset);break; }
			case 'U':{ replace=true;newChar=getChar(2329+offset);break; }
			case 'v':{ replace=true;newChar=getChar(2344+offset);break; }
			case 'V':{ replace=true;newChar=getChar(2345+offset);break; }
			case 'w':{ replace=true;newChar=getChar(2376+offset);break; }
			case 'W':{ replace=true;newChar=getChar(2320+offset);break; }
			case 'x':{ replace=true;newChar=getChar(2306+offset);break; }
			case 'X':{ replace=true;newChar=getChar(2305+offset);break; }
			case 'y':{ replace=true;newChar=getChar(2348+offset);break; }
			case 'Y':{ replace=true;newChar=getChar(2349+offset);break; }
			case 'z':{ replace=true;newChar=getChar(2374+offset);break; }
			case 'Z':{ replace=true;newChar=getChar(2318+offset);break; }
			case '[':{ replace=true;newChar=getChar(2337+offset);break; }
			case ']':{ replace=true;newChar=getChar(2364+offset);break; }
			case '{':{ replace=true;newChar=getChar(2338+offset);break; }
			case '}':{ replace=true;newChar=getChar(2334+offset);break; }
			case '"':{ replace=true;newChar=getChar(2336+offset);break; }
			case '\'':{ replace=true;newChar=getChar(2335+offset);break; }
			case ';':{ replace=true;newChar=getChar(2330+offset);break; }
			case ':':{ replace=true;newChar=getChar(2331+offset);break; }
			//case '.':{ replace=true;newChar=getChar(2379+offset);break; }
			case '<':{ replace=true;newChar=getChar(2359+offset);break; }
			//case ',':{ replace=true;newChar=getChar(2379+offset);break; }
			case '>':{ replace=true;newChar=getChar(2404+offset);break; }
			case '0':{ replace=true;newChar=getChar(2406+offset);break; }
			case '1':{ replace=true;newChar=getChar(2407+offset);break; }
			case '2':{ replace=true;newChar=getChar(2408+offset);break; }
			case '3':{ replace=true;newChar=getChar(2409+offset);break; }
			case '4':{ replace=true;newChar=getChar(2410+offset);break; }
			case '5':{ replace=true;newChar=getChar(2411+offset);break; }
			case '6':{ replace=true;newChar=getChar(2412+offset);break; }
			case '7':{ replace=true;newChar=getChar(2413+offset);break; }
			case '8':{ replace=true;newChar=getChar(2414+offset);break; }
			case '9':{ replace=true;newChar=getChar(2415+offset);break; }
			case '/':{ replace=true;newChar=getChar(2351+offset);break; }
			case '\\':{ replace=true;newChar=getChar(2377+offset);break; }
			case '~':{ replace=true;newChar=getChar(2378+offset);break; }
			case '|':{ replace=true;newChar=getChar(2321+offset);break; }
			case '?':{ replace=true;newChar=getChar(2399+offset);break; }
			case '!':{ replace=true;newChar=getChar(2317+offset);break; }
			case '@':{ replace=true;newChar=getChar(2373+offset);break; }
			case '#':{ replace=true;newChar=getChar(2322+offset);break; }
			case '_':{ replace=true;newChar=getChar(2307+offset);break; }
			case '+':{ replace=true;newChar=getChar(2315+offset);break; }
			case '=':{ replace=true;newChar=getChar(2371+offset);break; }
			case '&':{ //ksha
									replace=true;
									newChar=getChar1(2325+offset,2381+offset,2359+offset);
									break;
						 		}
			case '^':{ //tra
									replace=true;
									newChar=getChar1(2340+offset,2381+offset,2352+offset);
									break;
							 }
			case '*':{ //shra
									replace=true;
									newChar=getChar1(2358+offset,2381+offset,2352+offset);
									break;
						 	}
			case '%':{ //gna
									replace=true;
									newChar=getChar1(2332+offset,2381+offset,2334+offset);
									break;
							 }
			default :{ replace=false;}

		}
		return { replace:replace,newChar:newChar};
	}

	function getChar(code) {
		var newChar = String.fromCharCode(code);
		return newChar;
	}

	function getChar1(code1,code2,code3) {
		var newChar = String.fromCharCode(code1) +
					String.fromCharCode(code2) +
					String.fromCharCode(code3);
		return newChar;
	}

	/**
	  * Returns the Consonant of the selected Indian Language that the keycode maps to.
	  */
	function getConsonant(keyCode) {
		var key = String.fromCharCode(keyCode);
		switch(key) {	
			case 'a': { 
									vowelFlag = true; 
		      	  	  if(navigator.appName == "Netscape") {
										return ; 
									} 
									else if(navigator.appName == "IE") {
										return 0;
								}   
								break; 
			} 
			case 'Z': { 
							// If the input Language is either Tamil or Kannada
						if( (offset != 640) && (offset != 896) ) {
							return (2305+offset);
						}
						else {
							if(navigator.appName == "Netscape") {
								return -1;
							}
							else {  
								return 0;
							}
						}
						break; 
					} // "chandabindu"
					case 'M': { 
						return (2306+offset); 
						break; 
					} // DEVANAGARI CHARACTER "anuswar"
					case 'H': { 
						return(2307+offset); 
						break; 
					} // DEVANAGARI CHARACTER "visarg"
					case 'k': { 
						return(2325+offset); 
						break; 
					} // DEVANAGARI CHARACTER "ka"
					case 'K': {
						if(offset == 640) {	
							return(2325+offset);
						}
						else {
							return(2326+offset); // "kha"
						}
					break; 
					} 
					case 'g': { 
						if(offset == 640) {
							return(2325+offset);
						}
						else {
							return(2327+offset); //  "ga"
						}
					break; 
					} 
					case 'G': { 
						if(offset == 640) {
							return(2325+offset);
						}
						else {
							return(2328+offset); //  "gha"
						}
					break; 
					} 
					case 'f': { 
						return(2329+offset); //"nga"
						break; 
					} 
					case 'c': { 
						return(2330+offset); // "ca"
						break; 
					} 
					case 'C': { 
						if(offset == 640 ) { // if the input language is Tamil.
							return(2330+offset); // ca and cha are same in Tamil.
						}
						else {
							return(2331+offset);   // "cha"
						}
					break; 
					} 
					case 'j': { 
						return(2332+offset); // "ja"
						break; 
					} 
					case 'J': { 
						if(offset == 640) {
							return(2332+offset); // in tamil ja and jha are same.
						}
						else {
							return(2333+offset); //  "jha"
						}
						break; 
					} 
					case 'F': { 
						return(2334+offset); // "nya"
						break; 
					} 
					case 't': { 
						return(2335+offset); // "tta"
						break; 
					} 
					case 'T': { 
						if(offset == 640) {
							return(2335+offset); // in tamil tta and ttha are same.
						}
						else {
							return(2336+offset); //  "jha"
						}
						break; 
					} 
					case 'd': { 
						if(offset == 640) {
							return(2335+offset); // in tamil tta,ttha,dda are same.
						}
						else {
							return(2337+offset); //  "jha"
						}
						break; 
					} 
					case 'D': {
						if(offset == 640) {
							return(2335+offset); // in tamil tta,ttha,dda,ddha are same.
						}
						else {
							return(2338+offset); //  "ddha"
						}
						break; 
					}
					case 'N': { 
						return(2339+offset); // "nna"
						break; 
					} 
					case 'w': { 
						return(2340+offset); // DEVANAGARI CHARACTER "ta" 
						break; 
					} 
					case 'W': { 
						if(offset == 640) {
							return(2340+offset); // in tamil ta and tha are same.
						}
						else {
							return(2341+offset); //  "tha"
						}
						break; 
					}
					case 'x': {
						if(offset == 640) {
							return(2340+offset); // in tamil ta,tha,da are same.
						}
						else {
							return(2342+offset); //  "da"
						}
						break; 
					}			
					case 'X': { 
						if(offset == 640) {
							return(2340+offset); // in tamil ta,tha,da and dha are same.
						}
						else {
							return(2343+offset); //  "dha"
						}
						break; 
					}
					case 'n': { 
						return(2344+offset); // "na"
						break; 
					} 
					case 'p': { 
						return(2346+offset); // "pa"
						break; 
					} 
					case 'P': {
						if(offset == 640) {
							return(2346+offset); // in tamil pa,pha are same.
						}
						else {
							return(2347+offset); //  "dha"
						}
						break; 
					}
					case 'b': {
						if(offset == 640) {
							return(2346+offset); // in tamil pa,pha,ba are same.
						}
						else {
							return(2348+offset); //  "ba"
						}
						break; 
					}			
					case 'B': { 
						if(offset == 640) {
							return(2346+offset); // in tamil pa,pha,ba & bha are same.
						}
						else {
							return(2349+offset); //  "bha"
						}
						break; 
					}			
					case 'm': { 
						return(2350+offset); // "ma"
						break; 
					} 
					case 'y': { 
						return(2351+offset); // "ya"
						break; 
					} 
					case 'r': { 
						return(2352+offset); // "ra"
						break; 
					} 
					case 'l': { 
						return(2354+offset); // "la"
						break; 
					} 
					case 'v': { 
						if(offset == 128 || offset == 512) { // for Bengali and Oriya 'va' is 'ba'
							return (2348+offset);
						}
						else {
							return(2357+offset); // "va"
						}
						break; 
					} 
					case 'S': { 
						if(offset != 640) { //if the input language is not tamil.
							return(2358+offset); // "Sha"
						}
						break; 
					} 
					case 'R': { 
						return(2359+offset); // "SSa"
						break; 
					} 
					case 's': { 
						return(2360+offset); // "Sa"
						break; 
					} 
					case 'h': { 
						return(2361+offset); // "ha"
						break; 
					} 
					case 'z': { 
						if(offset < 640) { // 'Nukta' will not be in south indian scripts.
							return(2364+offset);
						}
						break; 
					} //  "Nukta" (only in North indian scripts).
					case 'A': { 
						return(2366+offset); // "aA"
						break; 
					} 
					case 'i': { 
						if(isNav && offset==0) {
							imatraFlag = true;
						}
						return(2367+offset); // Vowel Sign "ii"
						break; 
					} 
					case 'I': { 
						return(2368+offset); // Vowel Sign "iI"
						break; 
					} 
					case 'u': { 
						return(2369+offset); // Vowel Sign "u"
						break; 
					} 
					case 'U': { 
						return(2370+offset); // Vowel Sign "uU"
						break; 
					} 
					case 'q': { 
						return(2371+offset); // Vowel Sign Vocalic "R"
						break; 
					} 
					case 'e': { 
						if(offset == 896) {
							return (3270);
						}
						else if(offset == 768)  {
							return (3142);
						}
						else {
							return(2375+offset); // Vowel Sign "E"
						}
						break; 
					} 
					case 'E': { 
						return(2376+offset); // Vowel Sign "AI"
						break; 
					} 
					case 'o': { 
						return(2379+offset); // Vowel Sign "O"
						break; 
					} 
					case 'O': { 
						return(2380+offset); // Vowel Sign "AU"
						break; 
					} 
					case '_': { 
						return(2381+offset); // HALANT
						break; 
					} 
					case '.': { 
						if(offset < 640) { //if the input language is not a South indian lang.
							return(2404+offset); // VIRAM
						}
						else {
							return(46);
						}	 
						break;
					} 
					case '0': { 
						if(offset != 640) { 
							return(2406+offset); // DEVANAGARI DIGIT ZERO
						} 
						else { 
								if(navigator.appName == "Netscape") {
									return -1;
								}
								else { 
									return 0;
								}
						}
						break; 
					} 
					case '1': { 
						return(2407+offset); // DIGIT ONE
						break; 
					} 
					case '2': { 
						return(2408+offset); // DIGIT TWO
						break; 
					} 
					case '3': { 
						return(2409+offset); // DIGIT THREE
						break; 
					} 
					case '4': { 
						return(2410+offset); // DIGIT FOUR
						break; 
					} 
					case '5': { 
						return(2411+offset); // DIGIT FIVE
						break; 
					} 
					case '6': { 
						return(2412+offset); // DIGIT SIX
						break; 
					} 
					case '7': { 
						return(2413+offset); // DIGIT SEVEN
						break; 
					} 
					case '8': { 
						return(2414+offset); // DIGIT EIGHT
						break; 
					} 
					case '9': { 
						return(2415+offset); // DIGIT NINE
						break; 
					}
				}
			}

	/**
	  * This function handles the character which is keyed in and replaces it with the
	  * appropriate Indian Language character.
	  */
	function handleCharacter(textControl, event) {
	  
	  if(convertFlag) {

			//textControl = eval("document.forms[0]."+textAreaName);	
			var keyCode = event.keyCode ? event.keyCode :
					  event.charCode ? event.charCode :
					  event.which ? event.which : void 0;
			                                 
	    var key = String.fromCharCode(keyCode);
			if(keyboardSelected == "WX") {
				if(! ( keyCode == 8 || keyCode ==13 || keyCode == 47 ||
					keyCode == 96 || (keyCode >=32 && keyCode <=45) || 
					(keyCode >=58 && keyCode <=64) || (keyCode >=91 &&
					keyCode <=94) || (keyCode >122 && keyCode <=126) || 
					(keyCode == 86) || (keyCode == 89) || (keyCode == 9)
					|| (keyCode == 46) || (keyCode == 27)
					) ) //if
					{
						var keyCheck;
						keyCheck = replaceAsciiForWxLayout(keyCode,key);
						//If IE
						if (keyCode && window.event && !window.opera) {
			 				if (keyCheck.replaceKey) { 
								window.event.keyCode = keyCheck.newKey.charCodeAt(0);
								if(keyCheck.newKey.length == 2) {
									textControl.value = textControl.value +
									keyCheck.newKey.charAt(1);
								}
								if (window.event.preventDefault) { 
			   				  window.event.preventDefault();
								}
				        return true;
							}
						}//if
						//If netscape
						else if (typeof textControl.setSelectionRange != 'undefined') {
							if (keyCheck.replaceKey) {
					    	// cancel the key event and insert the newKey for the current selection
			   	 			if (event.preventDefault) {
			       	    event.preventDefault();
								}
			    	    oldSelectionStart = textControl.selectionStart;
						    oldSelectionEnd = textControl.selectionEnd;
								var selectedText = textControl.value.substring(
										oldSelectionStart,oldSelectionEnd);
						    var newText = typeof keyCheck.newKey != 'undefined' ?
								    keyCheck.newKey.charAt(0) : String.fromCharCode(
										keyCheck.newKey.charCodeAt(0));
								if(keyCheck.newKey.length == 2) {
									textControl.value = textControl.value.substring(0, 
									oldSelectionStart -1) + keyCheck.newKey.charAt(1) + 
									newText + textControl.value.substring(oldSelectionEnd);
								}
						    else if(vowel_nn) {
							    textControl.value = textControl.value.substring(0,
									(oldSelectionStart-1)) +  newText + textControl.value.substring(
									oldSelectionEnd);
							    vowel_nn = false;
						    }
						    else {
							    textControl.value = textControl.value.substring(0, 
									oldSelectionStart) +  newText + textControl.value.substring(
									oldSelectionEnd);
								}
								textControl.setSelectionRange(oldSelectionStart + newText.length,
							    oldSelectionStart + newText.length);
						    return false;
							}
							else {
								return true;
							}    
						}
					}// if not special symbols
					else if( keyCode == 86 || keyCode == 89) {
						var key = String.fromCharCode(keyCode);
						var textAreaContent = textControl.value;
						var lastCharCode = textAreaContent.charCodeAt(
								textAreaContent.length-1,textAreaContent.length);
								lastCharCode = lastCharCode - offset;
								isciiCode = getIsciiCode(lastCharCode);
						switch(key) {
							case 'V': {
													--isciiCode;
													unicode = getUnicodeFromIsciiCode(isciiCode);
													break;
												}
							case 'Y': {
													isciiCode++;
													unicode = getUnicodeFromIsciiCode(isciiCode);
													break;
												}
						}
						textControl.value = textControl.value.substring(
										0,textControl.value.length-1) +
										String.fromCharCode(unicode+offset);
						if(navigator.appName!="Netscape") {
							window.event.keyCode = 0;
						}
						else {
							event.preventDefault();
						}
					}
					else {
						if(vowelFlag) {
							var ch = String.fromCharCode((2309+offset));
							if(navigator.appName!="Netscape") {
								textControl.value = textControl.value + ch;
							}
							else{
								textControl.value = textControl.value + ch;
								textControl.value = textControl.value.substring(0,textControl.value.length-2) + ch;
								//textControl.value = textControl.value.substring(0,
									//oldSelectionStart) +  ch ;
							}
							vowelFlag = false;
						}
					}
			 }
			 else if(keyboardSelected == "INSCRIPT") {
					keyCheck = replaceAsciiForInscriptLayout(keyCode,key);
					 //If IE
			    if (keyCode && window.event && !window.opera) {
				    if (keyCheck.replaceKey) {
					    window.event.keyCode = keyCheck.newKey.charCodeAt(0);
					    if(keyCheck.newKey.length == 2) {
					       textControl.value = textControl.value +
					        keyCheck.newKey.charAt(1);
					    }
					    if (window.event.preventDefault) {
						     window.event.preventDefault();
						  }
        			return true;
        		}
      		}//if
      		//If netscape
				  else if (typeof textControl.setSelectionRange != 'undefined') {
        		if (keyCheck.replaceKey) {
        		// cancel the key event and insert the newKey 
						// for the current selection
				    if (event.preventDefault) {
        		  event.preventDefault();
        		}
        		var oldSelectionStart = textControl.selectionStart;
        		var oldSelectionEnd = textControl.selectionEnd;
        		var selectedText = textControl.value.substring(
        			oldSelectionStart,oldSelectionEnd);
        		var newText = typeof keyCheck.newKey != 'undefined' ?
        				keyCheck.newKey.charAt(0) : String.fromCharCode(
        				keyCheck.newKey.charCodeAt(0));
        				textControl.value = textControl.value.substring(0,
        				oldSelectionStart) + newText;
        		return false;
        	}
					else {
          	return true;
        	}
				}
			}
		}

		
		 // The function replaceAscii is different for the two layouts because Inscript has
		 // a one to one mapping, whereas WX layout does not.
		
			
	/**
		* This function replaces the key typed in with the new Indian Language Character for
		* Inscript layout.
		*/
		function replaceAsciiForInscriptLayout(keyCode,key) {
		   var unicodeCharacters = getUnicodeMappingForInscriptLayout(keyCode);
			 return { replaceKey:unicodeCharacters.replace, newKey:unicodeCharacters.newChar };
		}
		
		/**
		 * This function replaces the key typed in with the new Indian Language Character for
		 * WX layout.
		 */
		function replaceAsciiForWxLayout(keyCode,key) {
			var unicodeCharacters;
			unicodeCharacters = getUnicodeMappingForWxLayout(keyCode);
			if(unicodeCharacters.newKeyCode1==0) {
				newChar = String.fromCharCode(unicodeCharacters.newKeyCode2);
			}
			else {
				newChar = String.fromCharCode(unicodeCharacters.newKeyCode1) + 
				String.fromCharCode(unicodeCharacters.newKeyCode2);
			}
			return { replaceKey:true, newKey:newChar };  
		}
	}

	/**
	  * Returns the Unicode value of the isciicode passed.
	  */
	function getUnicodeFromIsciiCode(isciiCode) {
		isciiCode = isciiCode - 161;
		return isciiToUnicodeArray[isciiCode];
	}
		
	/**
    * Returns the iscii code of the unicode value passed.
 	  */	
	function getIsciiCode(unicode) {
		var isciiCode=0;
		for(var ai=0;ai<isciiToUnicodeArray.length;ai++) {
			if(isciiToUnicodeArray[ai] == unicode) {
			   isciiCode = ai + 161;	
		     break;
			}
		}
		return isciiCode;
	}			
}

/**
  * Stores the offset for the language selected.
	*/
imetoolbar.prototype.setOffset = function(value) {
				switch(value) {
					case '-1': {
						offset=0;
						convertFlag = false;
						break;
					}
					case '0' : { 
						offset=0;
						convertFlag = true;
						break; 
					}
					case '1' : { 
						offset=(128*1);
						convertFlag = true;
						break; 
					}
					case '2' : { 
						offset=(128*2);
						convertFlag = true;
						break; 
					}
					case '3' : { 
						offset=(128*3);
						convertFlag = true;
						break; 
					}
					case '4' : { 
						offset=(128*4);
						convertFlag = true;
						break; 
					}
					case '5' : { 
						offset=(128*5);
						convertFlag = true;
						break; 
					}
					case '6' : { 
						offset=(128*6);
						convertFlag = true;
						break; 
					}
					case '7' : { 
						offset=(128*7);
						convertFlag = true;
						break; 
					}
					case '8' : { 
						offset=(128*8);
						convertFlag = true;
						break; 
					}
					default: { 
						convertFlag=false;
					}
				}
	}

// Uninstall ******* 
imetoolbar.prototype.Uninstall = function(uninstallFrom){
  netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect"); 
  var confirmUninstall = confirm("Do you want to uninstall " + myToolbarName+ " ?" );
  
  if (!confirmUninstall) // user choose to cancel
    return;

  // remove the toolbar
  var myToolBar = document.getElementById(myToolbarId);
  myToolBar.parentNode.removeChild(myToolBar);

  // remove the view menu entry
  var myViewMenuEntry = document.getElementById("view_"+myToolbarId+"_menuitem");
  myViewMenuEntry.parentNode.removeChild(myViewMenuEntry);
  
  //remove the overlay entry in overlays.rdf
	var CONTAINER_NAME;
	if(uninstallFrom == "navigator") {
	  CONTAINER_NAME  = "chrome://navigator/content/navigator.xul";
	}
	else if(uninstallFrom == "editor") {
	  CONTAINER_NAME  = "chrome://editor/content/editor.xul";
	}
	
  var NODE_NAME       = "chrome://"+myToolbarId+"/content/"+myToolbarId+"Overlay.xul";

  var dirServ = Components.classes['@mozilla.org/file/directory_service;1'].createInstance();
  dirServ = dirServ.QueryInterface(Components.interfaces.nsIProperties);
  var processDir = dirServ.get("AChrom", Components.interfaces.nsIFile);
  processDir.append("overlayinfo");
	if(uninstallFrom == "navigator") {
	  processDir.append("navigator");
	}
	else if(uninstallFrom == "editor") {
	  processDir.append("editor");
	}
  processDir.append("content");
  processDir.append("overlays.rdf");

  removeRDFContainer(processDir, CONTAINER_NAME, NODE_NAME);

  // remove chrome.rdf entries

  CONTAINER_NAME = 'urn:mozilla:package:root';
  NODE_NAME = 'urn:mozilla:package:'+myToolbarId;

  processDir = dirServ.get("AChrom", Components.interfaces.nsIFile);
  processDir.append("chrome.rdf");

  // removeRDFDescription(processDir, CONTAINER_NAME, NODE_NAME);
  removeRDFContainer(processDir, CONTAINER_NAME, NODE_NAME);

  // remove the installed-chrome.txt entries - thanks to HJ for the code
  processDir = dirServ.get("AChrom", Components.interfaces.nsIFile);
  processDir.append("installed-chrome.txt");
  
  var entries = ReadFrom(processDir);
  entries = entries.replace(new RegExp('[^\\n\\r]+'+"resource:/chrome/"+myToolbarId+".jar!/content/"+'[\\n\\r]+', 'g'), '');
  WriteTo(processDir, entries); 
  
  function removeRDFContainer(fileRef, containerName, nodeName){
     netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect"); 
    var C                       = Components;
    const RDF_SRVC_PROG_ID      = '@mozilla.org/rdf/rdf-service;1';
    const RDF_CONTAINER_PROG_ID = '@mozilla.org/rdf/container;1';
    const RDF_DS_PROG_ID        = '@mozilla.org/rdf/datasource;1?name=xml-datasource';
    
    if (!fileRef.exists()) {
        return;
    }
 
    var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);

    // Interface change - ns7 (mozilla 1.0) needs nsIIOService, latter (mozilla 1.2) needs nsIFileProtocolHandler
    if(Components.interfaces.nsIFileProtocolHandler){
      var fileHandler = ioService.getProtocolHandler("file").QueryInterface(Components.interfaces.nsIFileProtocolHandler);  
      var myFileUrl = fileHandler.getURLSpecFromFile(fileRef);
    } else {
      var myFileUrl = ioService.getURLSpecFromFile(fileRef);    
    }  
  
	
    try {
      var rdf   = C.classes
                  [RDF_SRVC_PROG_ID].getService(C.interfaces.nsIRDFService);

      var ds    = rdf.GetDataSource(myFileUrl);
  
      var rem   = ds.QueryInterface(C.interfaces.nsIRDFRemoteDataSource);
      if (!rem.loaded) {
        rdf.UnregisterDataSource(ds);
        ds        = C.classes[RDF_DS_PROG_ID].
                    getService(C.interfaces.nsIRDFDataSource);
        rem       = ds.QueryInterface(C.interfaces.nsIRDFRemoteDataSource);
        rem.Init(myFileUrl);
      }
      rem.Refresh(true)
      var rs  = rdf.GetResource(containerName);
      var container = C.classes[RDF_CONTAINER_PROG_ID].
                           getService(C.interfaces.nsIRDFContainer);
      container.Init(rem, rs);

      var el = rdf.GetLiteral(nodeName); // remove if it's a literal
      container.RemoveElement(el, true);
      el = rdf.GetResource(nodeName); // remove it it's a resource
      container.RemoveElement(el, true);
      rem.Flush()
      rem.Refresh(true)
    } catch (e) {
      return;
    }
  }
  
  function ReadFrom(aFile) 
	{
    netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect"); 
		var stream = Components.classes['@mozilla.org/network/file-input-stream;1'].createInstance(Components.interfaces.nsIFileInputStream);
		stream.init(aFile, 1, 0, false); // open as "read only"

		var scriptableStream = Components.classes['@mozilla.org/scriptableinputstream;1'].createInstance(Components.interfaces.nsIScriptableInputStream);
		scriptableStream.init(stream);

		var fileSize = scriptableStream.available();
		var fileContents = scriptableStream.read(fileSize);

		scriptableStream.close();
		stream.close();

		return fileContents;
  }
  function WriteTo(aFile, aContent) 
	{
         netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect"); 
		if (aFile.exists()) aFile.remove(true);
		aFile.create(aFile.NORMAL_FILE_TYPE, 0666);

		var stream = Components.classes['@mozilla.org/network/file-output-stream;1'].createInstance(Components.interfaces.nsIFileOutputStream);
		stream.init(aFile, 2, 0x200, false); // open as "write only"

		stream.write(aContent, aContent.length);

		stream.close();
	}  
}

